<template>
  <div>
    <div style="margin: 3rem 5rem">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
          <h3 class="text-white">HISTORIAL DE MATERIALES</h3>
        </el-col>
        <div style="position:absolute; top:12.3rem; left:35%">
          <img src="../../../../assets/images/hist-enlatados.png" alt="reloj">
        </div>
      </el-header>
      <el-main style="margin: 5rem 8%">
        <el-row style="margin:0 5rem">
          <el-col style="margin: 1rem 0 2.5rem">
            <p>Aquí encontrarás la información del copiado de discos del material fílmico.</p>
            <p>Para buscarlo, ingresa el nombre o código del material que necesitas buscar.</p>
          </el-col>
          <el-col>
            <autocomplete 
              @handleSelect="handleSelect" 
              @querySearch="querySearch"  
              :text="originalTitle"
              placeholderText="Buscar"
              colorOrange='false'></autocomplete>
            <el-button @click="btnSearch" type="primary" style="margin-left: 4rem">BUSCAR</el-button>
          </el-col>
          <el-col>
            <!-- Tarjeta 'No hay resultado' -->
            <el-row style="margin-top:5rem" v-if="noCoincidence">
              <el-col :span="20">
                  <el-col :span="6" style="margin-top: 1rem" class="text-center">
                    <img src="../../../../assets/images/detective.svg" alt="detective" width="90px">
                  </el-col>
                  <el-col :span="16">
                    <div style="margin-top: 3rem">
                      <p class="subtitle-styles">¡Lo sentimos!</p>
                      <p class="subtitle-styles">No encontramos resultados para tu búsqueda </p>
                    </div>
                  </el-col>
              </el-col>
            </el-row>
          </el-col>
        </el-row>
      </el-main>
    </div>
  </div>
</template>

<style>
.autocompletado {
  width: 30rem
}
</style>

<script>

import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import autocomplete from '@/components/autocomplete.vue'
import { modifyText } from '../../../../utils/modifyText.js'
import { HTTP } from '../../../../main.js'

export default {
  components: {
    ReturnButton,
    autocomplete,
    'app-search-filter': SearchFilter
  },
  data () {
    return {
      links: [], // array de materiales seleccionado (de series o novelas o especiales)
      textSearch: '',
      idMaterial: '',
      noCoincidence: false,
      typeContent: localStorage.getItem('typeContentHistorial'),
      typeMaterialSelected: localStorage.getItem('typeMaterialSelected'),
      originalTitle: '',
      televisaMat: []

    }
  },
  created () {
    if(this.typeMaterialSelected == 'Especial'){
      this.getMaterialAffiliate('TELEVISA - ESPECIALES')
    } else if(this.typeMaterialSelected == 'Novelas'){
      this.getMaterialAffiliate('TELEVISA - TELENOVELAS')
    } else if(this.typeMaterialSelected == 'Series'){
      this.getMaterialAffiliate('TELEVISA - SERIES')
    }
    this.getMaterials()
  },
  methods: {
    getMaterialAffiliate(material){
      HTTP.get('materials/materialType/'+material)
      .then(res => {
        this.televisaMat = res.data.materials
      })
      .catch(err => {
        console.log(err);
      });
    },
    getMaterials () {
      HTTP.get('materials/materialType/Televisa/typeOfContent/' + this.typeMaterialSelected + '/providerName')
      .then(res => {
        let data = res.data.materials
        this.links = data.filter(e => e.stringMaterialType == "Afiliación-Televisa")
        console.log(this.links, 'this.links')
      })
      .catch(err => {
        console.log(err);
      });
    },
    returnPage () {
      this.$router.push({name: 'typeMaterials'})
    },
    btnSearch () {
      // 
      let idMat = this.idMaterial
      this.$localStorage.set('idRecordCanned', idMat)
      this.$localStorage.set('televisaHistorial', JSON.stringify(this.links.concat(this.televisaMat)))
      this.$router.push({name: 'tablaTelevisa'})
    },
    querySearch (queryString, cb) {
        var links = this.links.concat(this.televisaMat);
        var results = queryString ? links.filter(this.createFilter(queryString)) : links;
        console.log(results, 'results')
        cb(results);
    },
    createFilter (queryString) {
      return (link) => {
        return (link.originalTitle.toLowerCase().indexOf(queryString.toLowerCase()) !== -1)
      }
    },
    handleSelect (item) {
      this.$localStorage.set('elementSelectTelevisa', JSON.stringify(item))
      // console.log(item, item.originalTitle)
      this.originalTitle = item.originalTitle
      this.idMaterial = item.__id
    },
  }
}
</script>
